#!/usr/bin/perl 

###############################################################################
##OCS inventory Version 1.0 RC1
##Copyleft Pascal DANEK 2005
##Web : http://ocsinventory.sourceforge.net
##
##This code is open source and may be copied and modified as long as the source
##code is always made freely available.
##Please refer to the General Public Licence http://www.gnu.org/ or Licence.txt
################################################################################
use constant VERSION => '1.0-RC1';
#################################################
#Installation script for OcsInventory Linux Agent
#################################################
use XML::Simple;
use Compress::Zlib;
use Compress::Zlib;
use LWP::UserAgent;
use Net::IP qw(:PROC);
################
#THE SUBROUTINES
################

sub _deco{	
	system "clear";
	print <<HERE;
##################################################
#INSTALLATION SCRIPT FOR OCSINVENTORY LINUX AGENT#
##################################################



HERE
}

sub _method{
	#Local or export http?
	#If local, user will have to run the agent himself, and tranfer the compressed inventory on the ocs web server
	$err = 0;
	&_deco;
	while(!($err)){
		print "Wich method will you use to generate the inventory (http/Local): ";
		chomp($export=<STDIN>);
		($export=~/^http$|^local$/i)?$err=1:print "\nChoose a valid method (http ou local)\n";
	}
	#Server name
	#'Local' if not connected to the network
	if($export=~/http/i){
		print "\nServer name : ";
		chomp($ServerName=<STDIN>);
	}else{
		$ServerName='local';
	
	}
}	


#Creation of Device ID
sub _id{
	#Generation de l'identifiant
	chomp($Device=`hostname`);
	($YEAR, $MONTH , $DAY, $HOUR, $MIN, $SEC)=(localtime (time))[5,4,3,2,1,0];
	$DeviceID=sprintf "%s-%02d-%02d-%02d-%02d-%02d-%02d",  $Device, ($YEAR+1900), ($MONTH+1), $DAY, $HOUR, $MIN, $SEC;
}
	

#Request for auto-update
sub _update{
	&_deco;
	$fin=1;
	while($fin){
		print "Will you activate the auto-update ? (y/n) : ";
		chomp($AuthUpdate=<STDIN>);
		if($AuthUpdate=~/^y$|^n$/i){
			$fin=0;
			$AuthUpdate=~/^y$/?($AuthUpdate=1):($AuthUpdate=0);
		}
	}
}

sub _tag{
	#It's possible to put a file into the installation directory to be more explicit with the user concerning the tag nature.
	#Just put a text file with the keyword of the tag (exemple : service, unitid....)
	&_deco;
	if(-f "label"){
		open LABEL , "label";
		chomp($label=<LABEL>);
		close LABEL;
	}
	
	printf("Type the %s or return : ", $label?$label:'tag');
	chomp($tag=<STDIN>);
}


#Menu
sub _menu{	
	$choix=1;
	while($choix){
		&_deco;
		#Show the existing parameters
		print "\nCurrent parameters :\n\n";
		print "\t--- Account infos ---\n" if (keys %account);
		for(keys %account){
			print "\t\t".$_." = ".$account{$_}."\n";
		}
		print "\n\n";
		print                      "\t(1)Generating method      = $export\n";
		if($export=~/http/){print  "\t(1)Server name            = $ServerName\n";}	
		printf(                    "\t(2)Auto-update            = %s\n", $AuthUpdate?'on':'off');
		if(!$reinstall){printf(    "\n\t(3)%s = $tag\n",$label?$label:'tag');}
		
		print "\n\nType the number of the field you want to modify (or type '0') : ";
		chomp($choix=<STDIN>);
		if($choix==1){&_method}
		if($choix==2){&_update}
		if($choix==3){&_tag}
		if(($choix!=1)&&($choix!=2)&&($choix!=0)){
			print "Don't understand your choice\n"
		}
	}
}


#####
#MAIN
#####

####################
#Looking for context
####################

#Permissions checking
(-w "/etc") && (-w "/etc/cron.daily")?1:die "You don't have enough permissions to run this program. Are you really root ?\n";
#
#die "Don't find require directory\n" unless(-d "./require");
#Verifying existing installation ($reinstall flag)
&_deco;
if(-e "/etc/ocsinventory-client"){
	print "I found a previous installation. Do you want to continue ?(y/[n])";
	chomp($choix=<STDIN>);
	if(($choix=~/^n$/i) || ($choix eq "")){die "A bientot :-)\n";}
	elsif($choix=~/^y$/i){$reinstall=1;}#On met le flag reinstall  1
	else {die "Choix non compris\n";}
}


#If not a reinstall
if(!($reinstall)){
	#On gnre l'identifiant
	&_id;
	#On demande les renseignements
	&_method;
	&_update;
	&_tag;
		
#If that is
}else{
	#Get the Device ID
	unless(-r "/etc/ocsinventory-client/ocsinv.conf"){
		&_id;
		&_menu;       
	}else{
		#Reading configuration file
		$xmlconf = XMLin("/etc/ocsinventory-client/ocsinv.conf", SuppressEmpty => undef);
		$DeviceID = $xmlconf->{DEVICEID};
		$ServerName = $xmlconf->{OCSFSERVER};
		$AuthUpdate=1 if $xmlconf->{UPDATE} eq '1';
		
		if($ServerName=~/^local$/i){ $export='local' }else{ $export = 'http' }
		#Reading account informations file
		$xmladm=XMLin("/etc/ocsinventory-client/ocsinv.adm", SuppressEmpty => undef, , ForceArray => ['ACCOUNTINFO']);
		$i=0;
		while($xmladm->{ACCOUNTINFO}->[$i]->{KEYNAME}){
			$account{$xmladm->{ACCOUNTINFO}->[$i]->{KEYNAME}} = $xmladm->{ACCOUNTINFO}->[$i]->{KEYVALUE};
			$i++;
		}
		&_menu;
		
		#Device ID check
		chomp($Device=(`hostname`));
		unless($DeviceID=~/$Device-(\d{4})-(\d{2})-(\d{2})-(\d{2})-(\d{2})-(\d{2})/){
 			&_id;
		}
		else{
			if(!(($1>=2004)&&($1<2020)&&($2>=1)&&($2<=12)&&($3>=1)&&($3<=31)&&($4>=0)&&($4<=23)&&($5>=0)&&($5<=59)&&($6>=0)&&($6<=59))){
				&_id;
			}
		}
	}
}

#############
#INSTALLATION
#############

$fin=1;
while($fin){	
	&_deco;
	#Print the inputs
	print "Your inputs :\n\n";
	print                     "\tGenerating method   = $export\n";
	if($export=~/http/){print "\tServer name         = $ServerName\n";}
	printf(                   "\tAuto-update         = %s\n", $AuthUpdate?'on':'off');
	if(!$reinstall){printf("\n\t%s = $tag\n",$label?$label:'tag');}
	print  "\nDo you confirm ?  (y/[n]) : ";
	
	chomp ($choix=<STDIN>);
	if($choix=~/^y/i){$fin=0;}
	else{$fin=1; &_menu}
}

##########
#Writings
##########
#directories creation
#Installation directory
#if(-d "/etc/ocsinventory-client"){system("rm", "-rf", "/etc/ocsinventory-client")  and die "Cannot replace /etc/ocsinventory-client\n"}
#mkdir("/etc/ocsinventory-client") or die "Cannot create installation directory : $!\n";

#Log directory
if(-d "/var/log/ocsinventory-client"){system("rm", "-rf", "/var/log/ocsinventory-client")  and die "Impossible de remplacer /var/log/ocsinventory-client: $!\n"}
mkdir("/var/log/ocsinventory-client") or die "Cannot create logging directory : $!\n";

#writing of ocs.conf
$xmlconf{'DEVICEID'} = [ $DeviceID ];
$xmlconf{'OCSFSERVER'} = [ $ServerName ];
$xmlconf{'DMIVERSION'} = [ "1" ];
$xmlconf{'IPDISCOVER_VERSION'} = [ "1" ];
$xmlconf{'UPDATE'} = [ "1" ] if $AuthUpdate;
$xml = XML::Simple::XMLout( \%xmlconf, RootName => 'CONF' );
open CONF, ">/etc/ocsinventory-client/ocsinv.conf";
print CONF $xml;
close CONF;

open ADM, ">/etc/ocsinventory-client/ocsinv.adm" or warn "Cannot create account info file\n";
$xmladm{'ACCOUNTINFO'}[0]{'KEYNAME'} = [ "TAG" ];
$xmladm{'ACCOUNTINFO'}[0]{'KEYVALUE'} = [ $tag ];
$xml=XML::Simple::XMLout( \%xmladm , RootName=> "ADM");
print ADM $xml;
close ADM;

#Installation of ipdiscover and dmidecode
#system ("cp","ocsinventory-client.pl","/etc/ocsinventory-client") and die "Cannot copy ocs linux agent : $!\n";
#system ("cp -r require/* /etc/ocsinventory-client") and die "Cannot copy ocs linux binaries : $!\n"; 


#Cron task programmed (if http's way)
#####################################
unless($export=~/local/i){
	open CRON, ">/etc/cron.daily/ocsinventory-client" or die "Cannot put the cron task\n" ;
	
	($CRON = <<'HERE') =~ s/^\t//gm;
	#!/bin/sh
	#File generated by Ocs Inventory NG Installer
	ERRLOG="/root/###ocsinventory-client.log.err###"
	if [ -e '/bin/ocsinv' ]; then
		/bin/ocsinv
		exit 0;
	elif [ -e /usr/sbin/ocsinventory-client.pl ]; then
		perl /usr/sbin/ocsinventory-client.pl
		exit 0;
	else
		echo ---Error report of OCSInventory CRON task--- > $ERRLOG
		date >> $ERRLOG
		echo "Executable ocsinv introuvable..." >> $ERRLOG
		exit 1
	fi;

HERE
	
	print CRON $CRON;
	close CRON;
	chmod (0755, "/etc/cron.daily/ocsinventory-client");
}elsif($export=~/local/i){
	unlink "/etc/cron.daily/ocsinventory-client" if -e "/etc/cron.daily/ocsinventory-client";
}
##########
##########

#Creation of symbolic link in /bin
if(-l "/bin/ocsinv"){
	unlink "/bin/ocsinv";
}
symlink  "/usr/sbin/ocsinventory-client.pl", "/bin/ocsinv"
	or warn "Cannot create symbolic link in /bin : $!\n";

#####
#LOGS
#####
if(-d "/etc/logrotate.d"){
	unless(-e "ocsinventory-client"){
		open(LOGROTATE, ">/etc/logrotate.d/ocsng-linux-agent") or die "Cannot create the logrotate task : $!\n";
		print LOGROTATE <<'ROT';
#File generated by Ocs Inventory - NG installer
/var/log/ocsinventory-client/*.log{
	weekly
	rotate 7
	compress
	notifempty

}
ROT
	}
	
	close(LOGROTATE);
}else{
	print "'/etc/logrotate.d' is not accessible. Do not forget to create a logrotate task for /var/log/ocsinventory-client/ocsinv.log.\n";
	sleep(2);
}

#That's all
print "\n\nTerminated :-) \n";
#Sending the first inventory
system("ocsinv");














